.nolist
#include <avr/io.h>
#include "param.h"
.list

.section .bss

XStart:		.ds.b	1
YCnt:		.ds.b	1

#define XSIZEV	XVSIZESW

.section .text

.global TIMER1_OVF_vect
TIMER1_OVF_vect:
	push r16
	in r16, _SFR_IO_ADDR(SREG)
	push r16
	push XL
	push XH
	push r18

	lds XL, viewstart

	lds XH, YCnt			// Zeilenadresse laden
	inc XH
	cbi _SFR_IO_ADDR(PORTD), FLM

	ld r16, X+				// 320 bits ausgeben
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X

	cpi XH, YMin			// Zeilenzhler berechnen
	brne not_firstline		// Bildende ?
	sbi _SFR_IO_ADDR(PORTD), FLM
	wdr

#if ((defined(COMMAND_TIMEOUT))&&(COMMAND_TIMEOUT>0))
	lds r18, ctimeout
	dec r18
	sts ctimeout, r18
#endif

not_firstline:
	cpi XH, YScan			// VSync ?
	brlo SkipAdRes
	ldi XH, YMin-1			// Adresszhler Reset
SkipAdRes:
	sts YCnt, XH
	pop r18
	pop XH
	pop XL
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
	reti


.global lcd_writebyte		// X: r24
lcd_writebyte:				// Y: r22
							// DATA: r20
	cpi r24, (XSIZEV/8)
	brsh exitbyte
	cpi r22, lo8(YSIZE)
	brsh exitbyte
	mov XL, r24
	lsl XL
	mov XH, r22	
	subi XH, (-(YMin))
	st X,r20
exitbyte:
	ret
